#ifndef			_ARRAY_ENGINE_
#define			_ARRAY_ENGINE_

template	< class T >
class		clArray
{

public:

			int		intLength;

			clArray		( void );
			clArray		( int intLength );
	~		clArray		( void );

					operator T *	( void ) { return this->data; }
	clArray&		operator	=	( const clArray< T > & array );

	void	Add			( const T & item );
	void	Free		( void );

private:

	T		* data;

};

template	< class T >
clArray< T >::clArray( void )
{
	this->intLength = 0;
}

template	< class T >
clArray< T >::clArray( int intLength )
{
	this->data = ( T * )( malloc( sizeof( T ) * intLength ) );
	this->intLength = intLength;
}

template	< class T >
clArray< T >::~clArray( void )
{
	if( this->intLength )
		free( this->data );
	this->intLength = 0;
}

template	< class T >
clArray< T >& clArray< T >::operator = ( const clArray< T > & array )
{
	this->Free();
	int		intCopyLength = array.intLength * sizeof( T );
	this->data = ( T * )malloc( intCopyLength );

	memcpy( this->data, array.data, intCopyLength );
	this->intLength = array.intLength;

	return ( * this );
}

template	< class T >
void clArray< T >::Add( const T & item )
{
	if( !this->intLength )
		this->data = ( T * )malloc( this->intLength * sizeof( T ) + sizeof( T ) ); 
	else
	{
		this->data = ( T * )realloc( this->data, ( this->intLength * sizeof( T ) + sizeof( T ) ) );
	}
	this->data[ this->intLength ] = item;
	this->intLength ++;
}

template	< class T >
void clArray< T >::Free( void )
{
	if( this->intLength )
		free( this->data );
	this->intLength = 0;
}

#endif			// _ARRAY_ENGINE_
