#include		"FileSystem.h"

// File

clFile::clFile( void )
{
}

clFile::~clFile( void )
{
}

bool clFile::IsExists( const char * chName )
{
	FILE	* file;

	file = fopen( chName, "r" );
	if( file )
	{
		fclose( file );
		return true;
	}
	else
	{
		return false;
	}
}

bool clFile::CreateFile( const char * chName, bool bStrong )
{
	FILE	* file;

	if( !bStrong )
	{
		if( this->IsExists( chName ) )
		{
			return false;
		}
	}

	file = fopen( chName, "w" );
	if( file )
	{
		fclose( file );
		return true;
	}
	else
	{
		return false;
	}
}

// Directory

clArray< WIN32_FIND_DATA >	clDirectory::listItems;

clDirectory::clDirectory( void )
{
}

clDirectory::~clDirectory( void )
{
}

clArray< WIN32_FIND_DATA > & 	clDirectory::GetItems( const char * chNameDir )
{
	WIN32_FIND_DATA		wfd = { 0 };

	listItems.Free();
	SetCurrentDirectory( chNameDir );
	HANDLE		handleDir = FindFirstFile( "*", &wfd );
	listItems.Add( wfd );

	while( FindNextFile( handleDir, &wfd ) )
	{
		listItems.Add( wfd );
	}

	FindClose( handleDir );

	return listItems;
}

clArray< WIN32_FIND_DATA > & 	clDirectory::GetDirectories( const char * chNameDir )
{
	WIN32_FIND_DATA		wfd = { 0 };

	listItems.Free();
	SetCurrentDirectory( chNameDir );
	HANDLE		handleDir = FindFirstFile( "*", &wfd );
	if( wfd.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY )
	{
		listItems.Add( wfd );
	}

	while( FindNextFile( handleDir, &wfd ) )
	{
		if( wfd.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY )
		{
			listItems.Add( wfd );
		}
	}

	FindClose( handleDir );

	return listItems;
}

clArray< WIN32_FIND_DATA > & 	clDirectory::GetFiles( const char * chNameDir )
{
	WIN32_FIND_DATA		wfd = { 0 };

	listItems.Free();
	SetCurrentDirectory( chNameDir );
	HANDLE		handleDir = FindFirstFile( "*", &wfd );
	if( wfd.dwFileAttributes != FILE_ATTRIBUTE_DIRECTORY )
	{
		listItems.Add( wfd );
	}

	while( FindNextFile( handleDir, &wfd ) )
	{
		if( wfd.dwFileAttributes != FILE_ATTRIBUTE_DIRECTORY )
		{
			listItems.Add( wfd );
		}
	}

	FindClose( handleDir );

	return listItems;
}

bool clDirectory::CreateDirectory( const char * chName )
{
	return ( ::CreateDirectory( chName, NULL ) );
}

bool clDirectory::SetCurrentDirectory( const char * chName )
{
	return ( ::SetCurrentDirectory( chName ) );
}

void clDirectory::GetCurrentDirectory( clString & str )
{
	char	* charPath = new char[ 320 ];

	::GetCurrentDirectory( 320, charPath );
	str = charPath;

	delete [] charPath;
}