#include		"String.h"

char	* clString::chDataTemp;

void clString::funcInit( void )
{
	clString::chDataTemp = new char();
}

void clString::funcFree( void )
{
	delete [] clString::chDataTemp;
}

clString::clString( const char * chData )
{
	// Get length of string including 0x00 symbol
	this->intLength = strlen( chData ) + 1;
	
	this->chData = new char[ this->intLength ];
	strcpy( this->chData, chData );
}

clString& clString::operator =	( const clString & str )
{
	this->intLength = strlen( str.chData ) + 1;
	
	delete [] this->chData;

	this->chData = new char[ this->intLength ];
	strcpy( this->chData, str.chData );

	return ( * this );
}

clString& clString::operator +=	( const clString & str )
{	
	// this->intLength already have NULL character
	this->intLength += strlen( str.chData );	// 1 + ... 1 - is always
	
	char	* chRes = new char[ this->intLength ];
	
	strcpy( chRes, this->chData );
	strcat( chRes, str.chData );

	delete [] this->chData;
	this->chData = new char[ this->intLength ];
	strcpy( this->chData, chRes );
	
	delete [] chRes;
	
	return ( * this );
}

clString clString::operator +	( const clString & str )
{
	int		iLength = this->intLength + strlen( str.chData );
	delete [] clString::chDataTemp;
	clString::chDataTemp = new char[ iLength ];
	
	strcpy( clString::chDataTemp, this->chData );
	strcat( clString::chDataTemp, str.chData );
	
	return clString( clString::chDataTemp );
}

clString clString::operator +	( const char * ch )
{
	int		iLength = this->intLength + strlen( ch );
	delete [] clString::chDataTemp;
	clString::chDataTemp = new char[ iLength ];
	
	strcpy( clString::chDataTemp, this->chData );
	strcat( clString::chDataTemp, ch );
	
	return clString( clString::chDataTemp );
}

bool clString::operator == ( const clString & str )
{
	return ( !strcmp( this->chData, str.chData ) );
}

bool clString::operator == ( const char * ch )
{
	return ( !strcmp( this->chData, ch ) );
}

bool clString::operator != ( const clString & str )
{
	return ( strcmp( this->chData, str.chData ) );
}

bool clString::operator != ( const char * ch )
{
	return ( strcmp( this->chData, ch ) );
}

void clString::funcCutStart( const int i )
{
	if( ( i > 0 ) && ( i < this->intLength ) )
	{
		this->intLength -= i;
	
		char	* chRes = new char[ this->intLength ];
	
		strncpy( chRes, &this->chData[ i ], this->intLength );

		delete [] this->chData;
		this->chData = new char[ this->intLength ];

		strcpy( this->chData, chRes );
	
		delete [] chRes;
	}
}

void clString::funcCutEnd( const int i )
{
	if( ( i > 0 ) && ( i < this->intLength ) )
	{
		this->intLength -= i;
	
		char	* chRes = new char[ this->intLength ];
	
		strncpy( chRes, this->chData, this->intLength );

		delete [] this->chData;
		this->chData = new char[ this->intLength ];

		strcpy( this->chData, chRes );
	
		delete [] chRes;
	}
}

void clString::funcSwap( const char chFind, const char * chRepl )
{
	int		iLengthStr = strlen( chRepl );
	int		iCountFound = 0;
	int		iLengthRes = 0;
	int		i, c = 0;

	for( i = 0; i < this->intLength; i ++ )
	{
		if( this->chData[ i ] == chFind )
		{
			iCountFound ++;
		}
	}

	if( iCountFound > 0 )
	{
		char	* chRes = new char[ this->intLength ];
		memcpy( chRes, this->chData, this->intLength );
		delete [] this->chData;
		iLengthRes = this->intLength + ( iLengthStr - 1 ) * iCountFound;
		this->chData = new char[ iLengthRes ];

		for( i = 0; i < this->intLength; i ++ )
		{
			if( chRes[ i ] != chFind )
			{
				this->chData[ c ] = chRes[ i ];
				c ++;
			}
			else
			{
				for( int j = 0; j < iLengthStr; j ++ )
				{
					this->chData[ c ] = chRepl[ j ];
					c ++;
				}
			}
		}
		this->chData[ iLengthRes - 1 ] = 0x00;
		this->intLength = iLengthRes;

		delete [] chRes;
	}
}

int clString::funcStripTags( void )
{
	int		i = 0, j = 0;
	bool	bInside = false;
	int		iNewSize = 0;

	for( i = 0; i < this->intLength; i ++ )
	{
		if( this->chData[ i ] == '<' )
		{
			bInside = true;
		}
		if( this->chData[ i ] == '>' )
		{
			bInside = false;
		}

		if( ( !bInside ) && ( this->chData[ i ] != '>' ) && ( this->chData[ i ] != '<' ) )
		{
			iNewSize ++;
		}
	}

	char		* chRes = new char[ iNewSize + 1 ];

	for( i = 0; i < this->intLength; i ++ )
	{
		if( this->chData[ i ] == '<' )
		{
			bInside = true;
		}
		if( this->chData[ i ] == '>' )
		{
			bInside = false;
		}
		
		if( ( !bInside ) && ( this->chData[ i ] != '>' ) && ( this->chData[ i ] != '<' ) )
		{
			chRes[ j ] = this->chData[ i ];
			j ++ ;
		}
	}
	chRes[ iNewSize ] = 0x00;

	delete [] this->chData;
	this->intLength = iNewSize;
	
	this->chData = new char [ this->intLength ];
	strcpy( this->chData, chRes );

	return iNewSize;
}

void clString::funcToUpper( void )
{
	strupr( this->chData );
}

void clString::funcToLower( void )
{
	strlwr( this->chData );
}

int clString::funcFindString( const char * ch )
{
	int		iLength = strlen( this->chData ) - strlen( ch ) + 1;
	int		iLengthSmall = strlen( ch );
	bool	bAll = false;

	for( int i = 0; i < iLength; i ++ )
	{
		bAll = true;

		for( int j = 0; j < iLengthSmall; j ++ )
		{
			if( this->chData[ i + j ] != ch[ j ] )
			{
				bAll = false;
				break;
			}
		}

		if( bAll )
		{
			return i;
		}
	}

	return - 1;
}
